
when defined(android) or defined(emscripten) or defined(ios):
    import glad/gles32_static as gl
    export gl
else:
    import glad/gl as gl
    export gl

proc get_shader_info_log*(shader: GLuint): string =
    var logSize: GLint
    glGetShaderiv(shader, GL_INFO_LOG_LENGTH, addr logSize)
    var s = newString(logSize)
    glGetShaderInfoLog(shader, logSize.GLsizei, nil, s.cstring)
    return s

proc get_program_info_log*(program: GLuint): string =
    var logSize: GLint
    glGetProgramiv(program, GL_INFO_LOG_LENGTH, addr logSize)
    var s = newString(logSize)
    glGetProgramInfoLog(program, logSize.GLsizei, nil, s.cstring)
    return s


