#if MAX_SHADOW_MAPS
float get_shadow(vec3 position, int index) {
    vec3 co = vec3(shadow_map_infos[0].depth_matrix * vec4(position, 1.0));
    if(co.x < 0.0 || co.x >= 1.0 || co.y < 0.0 || co.y >= 1.0) return 1.0;
    co.z = min(co.z, 0.999999);
#if USE_SHADOW_SAMPLERS
    return texture(shadow_maps[0], co);
#else
    // vec2 co2 = co.xy * shadow_map_infos[0].size;
    // vec2 co20 = floor(co2);
    // ivec2 ico = vec2(co20);
    // return mix(
    //     texelFetch(shadow_maps[0], )
    // )
    float px_size = 2.0/shadow_map_infos[0].size;
    float count = 0.0;
    float vis = 0.0;
    for(float y=co.y-px_size;y<=co.y+px_size;y+=px_size*0.499){
        for(float x=co.x-px_size;x<=co.x+px_size;x+=px_size*0.499){
            vis += texture(shadow_maps[0], vec2(x,y)).r <= co.z?0.0:1.0;
            count += 1.0;
        }
    }
    // return mix(vis/count, 1.0, 0.14);
    return vis/count;
#endif
}
#endif
